//天気予報を取得するAPIです。
var apiURL = "http://api.openweathermap.org/data/2.5/forecast";

//APIを呼び出すパラメータです。
var data = {
	"q" : properties.location,
	"APPID" : properties.apiKey
};

//非同期通信で呼び出します。
ajax ({
	url : apiURL,
	data : data,
	type : "get",
	timeout : 5000,
	success : function ( contents ) {
		//コンテンツのチェック
		if ( !contents.list || !contents.list[ 0 ] || !contents.list[ 0 ].weather || !contents.list[ 0 ].weather[ 0 ] || !contents.list[ 0 ].weather[ 0 ].id ) {
			log("Weather : Invalid data");
			runtimeValues.outputIndex = -1;
			callbackSuccess( {
				resultType : "continue",
				runtimeValues : runtimeValues
			} );
		}

		log(JSON.stringify(contents));

		//天気を示すIDを取得します。
		var idNum = contents.list[ 0 ].weather[ 0 ].id + 0;
		log("Weather condition code = " + idNum);

		if (idNum < 200) { // Undefined
			runtimeValues.outputIndex = 0;
		} else if ( idNum < 300 ) { // Thunderstorm
			runtimeValues.outputIndex = 3;
		} else if ( idNum < 500 ) { // Drizzle
			runtimeValues.outputIndex = 3;
		} else if ( idNum < 600 ) { // Rain
			runtimeValues.outputIndex = 3;
		} else if ( idNum < 700 ) { // Snow
			runtimeValues.outputIndex = 4;
		} else if ( idNum < 800 ) { // Atmosohere
			runtimeValues.outputIndex = 5;
		} else if ( idNum == 800 ) { // Clear
			runtimeValues.outputIndex = 1;
		} else { // Clouds
			runtimeValues.outputIndex = 2;
		}

		log(runtimeValues.outputIndex);
		
		callbackSuccess( {
			resultType : "continue",
			runtimeValues : runtimeValues
		} );
	},
	error : function ( request, errorMessage ) {
		log(JSON.stringify(request));
		log(JSON.stringify(errorMessage));
		runtimeValues.outputIndex = -1;
		callbackSuccess( {
			resultType : "continue",
			runtimeValues : runtimeValues
		} );
	}
});
 
return {
	resultType : "pause"
};