//Theta Endpoint URLの設定（デフォルトは192.168.1.1）
var endPointURL = "http://192.168.1.1"

var startSessionJSONData = {
	name: "camera.startSession"
} 

ajax( {
	url : endPointURL + "/osc/commands/execute",
	type : "post",
	data : JSON.stringify( startSessionJSONData),
	contentType: "application/json",
	dataType: "json",
	timeout : 5000,
	success : function (contents) {
		//取得したセッションIDをruntimeValuesに保管
		runtimeValues.sessionId = contents.results.sessionId;
		log("Theta session started: " + runtimeValues.sessionId);
		//CaptureModeのチェック
		checkCaptureMode(endPointURL);
		//シャッターを切る
		takeThetaPicture(endPointURL);
		//セッションのクローズ
		closeThetaSession(endPointURL);
		callbackSuccess( {
					resultType : "continue",     
					runtimeValues : runtimeValues
		});
	},
	error : function (XMLHttpRequest, textStatus, errorThrown) {
		log(XMLHttpRequest + " | " + textStatus + " | " + errorThrown);		
		callbackSuccess({
			resultType: "continue"
		});
	}
});

function checkCaptureMode(endPointURL) {
	var getOptionsJSONData = {
		name: "camera.getOptions",
		parameters: {
			sessionId: runtimeValues.sessionId,
			optionNames: ["captureMode"]
		}
	} 
	
	ajax( {
		url : endPointURL + "/osc/commands/execute",
		type : "post",
		data : JSON.stringify( getOptionsJSONData),
		contentType: "application/json",
		dataType: "json",
		timeout : 5000,
		success : function (contents) {
			log("CaptureMode: " + JSON.stringify(contents.results.options.captureMode));
			if(contents.results.options.captureMode != "image"){
				log("Please change capture mode to take photo");
				callbackSuccess({
					resultType: "stop"
				});
			};	
			callbackSuccess( {
					resultType : "continue"
			});
		},
		error : function (XMLHttpRequest, textStatus, errorThrown) {
			log("Error:" + textStatus + " " + errorThrown);		
			callbackSuccess({
				resultType: "continue"
			});
		}
	} );
}

function takeThetaPicture(endPointURL) {
	var takePictureJSONData = {
		name: "camera.takePicture",
		parameters: {
			sessionId: runtimeValues.sessionId
		}
	} 

	ajax( {
		url : endPointURL + "/osc/commands/execute",
		type : "post",
		data : JSON.stringify( takePictureJSONData),
		contentType: "application/json",
		dataType: "json",
		timeout : 5000,
		success : function (contents) {
				log("Took picture");
		},
		error : function (XMLHttpRequest, textStatus, errorThrown) {
			log("Error:" + textStatus + " " + errorThrown);		
			callbackSuccess({
				resultType: "continue"
			});
		}
	} );
}

function closeThetaSession(endPointURL) {
	var closeSessionJSONData = {
		name: "camera.closeSession",
		parameters: {
			sessionId: runtimeValues.sessionId
		}
	} 

	ajax( {
		url : endPointURL + "/osc/commands/execute",
		type : "post",
		data : JSON.stringify( closeSessionJSONData),
		contentType: "application/json",
		dataType: "json",
		timeout : 5000,
		success : function (contents) {
			log("Theta session closed: " + runtimeValues.sessionId);
			},
		error : function (XMLHttpRequest, textStatus, errorThrown) {
			log("Error:" + textStatus + " " + errorThrown);		
			callbackSuccess({
				resultType: "continue"
			});
		}
	} );
}

return {
	resultType : "continue"
};